import java.util.*;

public class Main {
    public static void main(String[] args) {
        //ZADANIE 1
        // Utwórz nową listę tablicową, dodaj kilka stringów zawierających nazwy kolorów
        ArrayList<String> list_Strings = new ArrayList<>();
        list_Strings.add("Red");
        list_Strings.add("Green");
        list_Strings.add("Orange");
        list_Strings.add("White");
        list_Strings.add("Black");

        System.out.println(list_Strings);

        // print the list
        System.out.println("Wyświetl listę używając indeksów");
        for(int i = 0; i < list_Strings.size(); i++){
            System.out.println(list_Strings.get(i));
        }

        // print the list from given index, e.g. 2
        System.out.println("Wyświetl listę od 2go indeksu");
        for(int i = 2; i < list_Strings.size(); i++){
            System.out.println(list_Strings.get(i));
        }

        //  print list from index given by user
        System.out.println("Wyświetl listę od podanego przez Ciebie indeksu");
        int givenIndex;
        Scanner scanInput = new Scanner(System.in);
        do {
            System.out.println("Podaj index startowy");
            givenIndex = scanInput.nextInt();
        } while (givenIndex < 0 || givenIndex >= list_Strings.size());

        System.out.println("Lista od indexu " + givenIndex);
        for(int i = givenIndex; i < list_Strings.size(); i++){
            System.out.println(list_Strings.get(i));
        }

        // lista od końca
        System.out.println("Lista od końca ");
        for(int i = list_Strings.size() - 1; i >= 0; i--){
            System.out.println(list_Strings.get(i));
        }

        // wstaw Pink na początek listy
        System.out.println("wstaw Pink na początek listy");
        list_Strings.add(0, "Pink");
        System.out.println(list_Strings);

        // wstaw przed Black kolor Yellow
        System.out.println("wstaw przed Black kolor Yellow");
        list_Strings.add(5, "Yellow");
        System.out.println(list_Strings);
        // lub
        list_Strings.add(list_Strings.indexOf("Black"), "Yellow2");
        System.out.println(list_Strings);

        // wyświetl liste przy pomocy for each
        System.out.println("Wyświetl liste przy pomocy for each");
        for(String color : list_Strings){
            System.out.println(color);
        }

        System.out.println("Wyświetl liste przy pomocy iteratora");
        //Traversing list through Iterator
        Iterator<String> itr = list_Strings.iterator(); //getting the Iterator
        while(itr.hasNext()){ //check if iterator has the elements
            System.out.println(itr.next()); //printing the element and move to next
        }

        // pobierz pierwszy i trzeci element
        String element = list_Strings.get(0);
        System.out.println("Pierwszy element: " + element);
        element = list_Strings.get(2);
        System.out.println("Trzeci element: " + element);

        // Update the 2 element with "Blue"
        System.out.println("Zmień drugi element na Blue");
        list_Strings.set(1, "Blue");
        // Print the list again
        System.out.println(list_Strings);

        // Remove the second element from the list
        list_Strings.remove(1);
        // Print the list again
        System.out.println("Po usunięciu drugiego elementu:\n" + list_Strings);

        // Search the value Red
        if (list_Strings.contains("Red")) {
            System.out.println("Red jest na liście");
        } else {
            System.out.println("Red nie ma liście");
        }

        System.out.println("Lista przed sortowaniem: "+list_Strings);
        Collections.sort(list_Strings);
        System.out.println("Lista po sortowaniu: " + list_Strings);
        //lub
        list_Strings.add(2,"Salmon");
        list_Strings.add("Purple");
        list_Strings.sort(null);
        System.out.println("Zupdatowana lista po sortowaniu: " + list_Strings);

        // tworzymy nową, przykładową listę
        // Arrays.asList - lista o stałej dlugości, List.Of niemodyfikowala
        // List.of w konstruktorze - modyfikowalna
        ArrayList<String> colorList = new ArrayList<>(List.of("Red", "Blue", "Green"));
        System.out.println("Druga lista: " + colorList);
        // do listy dodaj listę color_list o elementach Red Blue Green
        list_Strings.addAll(colorList);
        System.out.println("list_Strings po dodaniu drugiej listy: " + list_Strings);

        // creating sublist
        List<String> sub_List = list_Strings.subList(0, 3);
        System.out.println("Podlista: " + sub_List);

        // usuwanie listy elementów
        list_Strings.removeAll(colorList);
        System.out.println("Po usunięciu elementów z colorList: " + list_Strings);

        // usuwanie wszystkich elementów
        colorList.clear();
        if(colorList.isEmpty()) System.out.println("colorList jest pusta");
        else System.out.println("colorList ma elementy");

        LinkedList<String> l_list = new LinkedList<String>();
        // use add() method to add values in the linked list
        l_list.add("Red");
        l_list.add("Green");
        l_list.add("Black");
        l_list.add("White");
        l_list.add("Pink");
        l_list.add("Yellow");

        // print original list
        System.out.println("Nowa LinkedList:" + l_list);

        // Find first element of the List
        String first_element = l_list.getFirst();
        System.out.println("Pierwszy element: "+ first_element);

        // Find last element of the List
        String last_element = l_list.getLast();
        System.out.println("Ostatni element "+ last_element);
        String x = l_list.peek();
        System.out.println("First element in the list: " + x);
        System.out.println("Original linked list: " + l_list);

        //Convert a linked list to array list
        ArrayList<String> list = new ArrayList<String>(l_list);
        System.out.println("Converted list: " + list);
    }
}